flint()

NAME
FLINT - FLash INTerface InfiniHost flash memory operations.

SYNOPSYS
flint [switches...] <command> [parameters...]

OPTIONS
    -bsn <BSN> - Mellanox Board Serial Number (BSN).
                        Valid BSN format is:
                        MTxxxxx[-]R[xx]ddmmyy-nnn[-cc]
                        Commands affected: burn
    -crc - Print CRC after each section when verify.
    -d[evice] <device> - Device flash is connected to.
                        Commands affected: all
    -guid <GUID> - Base value for up to 4 GUIDs, which
                        are automatically assigned the
                        following values:
                        guid -> node GUID
                        guid+1 -> port1
                        guid+2 -> port2
                        guid+3 -> system image GUID.
                        Note: For a single port HCA, port2 guid is assigned
                        with the 'guid + 2' value, although it is ignored.
                        Commands affected: burn
    -guids <GUIDs...> - 4 GUIDs must be specified here.
                        The specified GUIDs are assigned
                        the following values, repectively:
                        node, port1, port2 and system image GUID.
                        Note: For a single port HCA, port2 guid must be
                        specified (can be set to 0x0), although it is ignored.
                        Commands affected: burn
    -clear_semaphore - Force clear of the flash semaphore on the device.
                        This flag should come BEFORE the -d[evice] flag in the command line.
                        No command is allowed when this flag is used.
                        NOTE: Using this flag may result in an unstable behavior and flash image
                        corruption if the device or another flash application is currently
                        using the flash. Handle with care.
    -h[elp] - Prints this message and exits
    -hh - Prints extended command help
    -i[mage] <image> - Binary image file.
                        Commands affected: burn, verify
    -nofs - Burn image not in failsafe manner.
    -skip_is - Allow burning the FW image without updating the invariant sector,
                        to insures failsafe burning even when invariant sector difference is detected.
                        See the specific FW release notes for more details.
    -byte_mode - Shift address when accessing flash internal registers. May
                        be required for burn/write commands when accessing certain
                        flash types.
    -s[ilent] - Do not print burn progress flyer.
                        Commands affected: burn
    -y[es] - Non interactive mode - assume answer
                        "yes" to all questions.
                        Commands affected: all
    -vsd <string> - Write this string, of up to 208 characters, to VSD when burn.
    -psid <PSID> - Write the Parameter Set ID (PSID) string to PS-ID field (last 16 bytes of VSD) when burn.
    -use_image_ps - Burn vsd as appears in the given image - don't keep existing vsd on flash.
                        Commands affected: burn
    -dual_image - Make the burn process burn two images on flash (previously default algorithm). Current
                        default failsafe burn process burns a single image (in alternating locations).
                        Commands affected: burn
    -v - Version info. Commands summary (use -hh flag for full commands description):
    b[urn] - Burn flash
    e[rase] - Erase sector
    q[uery] - Query misc. flash/FW characteristics
    rw - Read one dword from flash
    v[erify] - Verify entire flash
    ww - Write one dword to flash
    bb - Burn Block - Burns the given image as is. No checks are done.
    wwne - Write one dword to flash without sector erase
    wbne - Write a data block to flash without sector erase
    rb - Read a data block from flash
    ri - Read the fw image on the flash.
    dc - Dump Configuration: print fw configuration file for the given image. Command descriptions: * Burn flash
  Burns entire flash from raw binary image.
    Command:
        b[urn]
    Parameters:
        None
    Examples:
        flint -d /dev/mst/mt23108_pci_cr0 -i image1.bin burn
        flint -d /dev/mst/mt23108_pciconf0 -guid 0x2c9000100d050 -i image1.bin b * Burn Block
  Burns entire flash from raw binary image as is. No checks are done on the flash or
  on the given image file. No fields (such as VSD or Guids) are read from flash.
    Command:
        bb
    Parameters:
        None
    Examples:
        flint -d /dev/mst/mt23108_pci_cr0 -i image1.bin bb * Erase sector.
  Erases a sector that contains specified address.
    Command:
        e[rase]
    Parameters:
        addr - address of word in sector that you want
                   to erase.
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 erase 0x10000 * Query miscellaneous FW and flash parameters
    Command:
        q[uery]
    Parameters:
        None
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 query * Query flash device parameters (Common Flash Interface)
    Command:
        cfi
    Parameters:
        None
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 cfi * Read one dword from flash.
    Command:
        rw
    Parameters:
        addr - address of word to read
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 rw 0x20 * Verify entire flash.
    Command:
        v[erify]
    Parameters:
        None
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 v * Write one dword to flash.
  Note that the utility will read an entire flash sector,
  modify one word and write the sector back. This may take
  a few seconds.
    Command:
        ww
    Parameters:
        addr - address of word
        data - value of word
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 ww 0x10008 0x5a445a44 * Write one dword to flash without sector erase.
  Note that the result of operation is undefined and depends
  on flash type. Usually "bitwise AND" (&) between specified
  word and previous flash contents will be written to
  specified address.
    Command:
        wwne
    Parameters:
        addr - address of word
        data - value of word
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 wwne 0x10008 0x5a445a44 * Read a data block from the flash and write it to a file or to screen.
    Command:
        rb
    Parameters:
        addr - address of block
        size - size of data to read in bytes
        file - filename to write the block (raw binary). If not given, the data
               is printed to screen
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 rb 0x10000 100 file.bin * Read the FW image from flash and write it to a file.
    Command:
        ri
    Parameters:
        file - filename to write the image to (raw binary).
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 ri file.bin * Write a block of data to the flash without erasing.
    Command:
        wbne
    Parameters:
        addr - address of block
        size - size of data to write in bytes
        data - data to write - space seperated dwords
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 wbne 0x10000 12 0x30000 0x76800 0x5a44 5a44 * Print (to screen or to a file) the firmware configuration text file used by the image generation process.
  This command would fail if the image does not contain a FW configuration section. Existence of this
  section depends on the version of the image generation tool.
    Command:
        dc
    Parameters:
        file - (optional) filename to write the dumped configuration to. If not given, the data
               is printed to screen
    Example:
        flint -d /dev/mst/mt23108_pci_cr0 dc

KNOWN ISSUES
After kill or interrupt to flint, the HCA internal flash semaphore may not be released, and prevent further activation of flint. Use the -clear_semaphore flag to force clearing of this semaphor.